/* 
MUSIC 220B, HW1: Homebrew
"Requiem for Caffeine"
Cara Turnbull
*/



//-----------------------Basic Utilities------------------------//

fun void playClip(string clipName, float gain) {
    me.sourceDir() + clipName => string filename;
    if( me.args() ) me.arg(0) => filename;
    SndBuf buf => dac;
    gain => buf.gain;
    filename => buf.read;
    now + buf.length() + 2::second => time later;
    while( now < later ) {
        100::ms => now;
    }
}

fun void playClipReverse(string clipName, float gain, float rate) {
    me.sourceDir() + clipName => string filename;
    if( me.args() ) me.arg(0) => filename;
    SndBuf buf => dac;
    gain => buf.gain;
    rate => buf.rate;
    filename => buf.read;
    buf.samples() - 1 => int pos;
    buf.samples() => int end;
    while( end > 0 ) {
        pos => buf.pos;
        pos--;
        end--;
        1::samp => now;
        
    }
}

//-------------------Specialized Sndbuf Playbacks---------------//

fun void ahh() {
    me.sourceDir() + "ahh.wav" => string filename;
    if( me.args() ) me.arg(0) => filename;
    SndBuf buf => NRev rev => dac;
    .5 => buf.gain;
    .75 => rev.mix;
    .5 => rev.gain;
    filename => buf.read;
    now + buf.length() + 1::second => time later;
    while( now < later ) {
        100::ms => now;
    }
}

fun void dreamWater() {
    me.sourceDir() + "fill.wav" => string filename;
    if( me.args() ) me.arg(0) => filename;
    SndBuf buf => NRev r => dac; 
    .15 => r.mix;
    .3 => r.gain;
    //2.5 => buf.rate;
    .7 => buf.gain;
    filename => buf.read;
    buf.samples() - 1 => int pos;
    buf.samples() => int end;
    while( end > 89200 ) {
        pos => buf.pos;
        pos--;
        end--;
        1::samp => now;
    }
}

fun void brewCoffee() {
    me.sourceDir() + "brew.wav" => string filename;
    if( me.args() ) me.arg(0) => filename;
    SndBuf buf => dac;
    .25 => buf.gain;
    filename => buf.read;
    now + 97::second + 500::ms => time later;
    while( now < later ) {
        100::ms => now;
    }
}

fun void coffeeGrinder(float shiftAmt) {
    me.sourceDir() + "grind.wav" => string filename;
    if( me.args() ) me.arg(0) => filename;
    SndBuf buf => PitShift shift => dac;
    .08 => buf.gain;
    .5 => buf.rate;
    1 => shift.mix;
    shiftAmt => shift.shift;
    filename => buf.read;
    now + buf.length() * 2 => time later;
    while( now < later ) {
        100::ms => now;
    }
}

fun void beansEcho() {
    me.sourceDir() + "beans.wav" => string filename;
    if( me.args() ) me.arg(0) => filename;
    SndBuf buf => NRev r => Echo a => Echo b => Echo c => dac;
    5000::ms => a.max; 
    5000::ms => b.max; 
    5000::ms => c.max;
    250::ms => a.delay;
    500::ms => b.delay; 
    1000::ms => c.delay;
    .75 => a.mix => b.mix => c.mix;
    0 => r.mix;
    .5 => r.gain;
    1.2 => buf.gain;
    .3 => buf.rate;
    filename => buf.read;
    now + buf.length() * 4 => time later;
    while( now < later ) {
        100::ms => now;
    }
}

fun void beanBeat(int speed, float rangeLow, float rangeHigh) {
    me.sourceDir() + "oneBean.wav" => string filename;
    if( me.args() ) me.arg(0) => filename;
    SndBuf buf => PitShift shift => NRev rev => Echo a => Echo b => Echo c => dac; 
    .3 => rev.gain;
    .1 => rev.mix;
    1000::ms => a.max => b.max => c.max;
    750::ms => a.delay => b.delay => c.delay;
    .50 => a.mix => b.mix => c.mix;
    6 => buf.gain;
    .75 => shift.mix;
    while (true) {
        Math.random2f(rangeLow, rangeHigh) => shift.shift;
        filename => buf.read;
        speed::ms => now;
    }
}

//------------------------Bean Module------------------------//
fun void beans() {
    now + 60::second => time later;
    spork ~playClipReverse("beans.wav", 1, 1);
    5::second => now;
    spork ~playClip("beans.wav", 1);
    spork ~beansEcho();
    17::second => now;
    spork ~beanBeat(500, 0, 5);
    10::second => now;
    spork ~playClip("beans.wav", .1);
    spork ~beanBeat(1000, 0, 5);
    10::second => now;
    spork ~beanBeat(2000, 0, .1);
    while (now < later) {
        100::ms => now;
    } 
}

//----------------Master Control Program (MCP)----------------//

//intro
spork ~playClip("slurp.wav", 1);
1::second => now;
spork ~ahh();
spork ~brewCoffee();
1::second => now;

//transition to dreamstate
spork ~dreamWater();
12::second => now;

//bean party
spork ~playClipReverse("beansShort.wav", .5, 1.25);
4::second => now;
spork ~coffeeGrinder(1);
4::second => now;
spork ~coffeeGrinder(.25);
4::second => now;
spork ~coffeeGrinder(.5);
8::second => now;
spork ~beans();
58::second => now;

//transition out of beans
spork ~playClipReverse("beansShort.wav", 1.25, .75);
5::second => now;

//wakeup <- asleep
spork ~playClipReverse("ahh.wav", .25, .75);
3::second => now;